const $ = require("jquery");
const { openNewWin, isIe8 } = require('./promise.js');
const { bindTipsEvent } = require('./popupEdit.js');
let showImg = require('./../images/show.png')
let collapseImg = require('./../images/collapse.png')

const is8Ie = isIe8() //判断是否为IE8
if(is8Ie) {
  let reg = /undefined/g
  showImg = showImg.replace(reg, '')
  collapseImg = collapseImg.replace(reg, '')
}

//推荐诊断等单种类型的
function renderRecommendInfo(icon, className,title,data, hasInfo, type, position) {
    const str = `<div class="recommendInfoWrapper ${className} clearfix">
                    <h4><img src=${icon} title="${title}" class="icon">${title}:</h4>
                    <div class="recommendInfoBox">
                        <div class="clearfix recommendInfoItemBox ${className + 'box'}">
                        </div>
                    </div>
                </div>`
    $('.push').append(str)
    let childrenNodeStr = ''
    if(hasInfo) {
        for (let i = 0; i < data.length; i++) {
            childrenNodeStr += `<span class="recommendInfoItem recommendInfoItemHasInfo">
                                    ${data[i].name}
                                    <span  title="点击名称可看详细说明" class="infoMsg" data-name=${data[i].name}></span>
                                </span>`
        }
    } else {
        for (let i = 0; i < data.length; i++) {
            childrenNodeStr += `<span class="recommendInfoItem" data-name="${data[i].name}">
                                    ${data[i].name}
                                </span>`
        }
    }
    if(!childrenNodeStr) {
        childrenNodeStr = '<span class ="recommendNull">暂无推荐</span>'
    }
    $('.'+className + 'box').append(childrenNodeStr)
    let childrenNodeStrAll = `<div class="${className+'boxAll'} itemAllBox">
            <h4>${title}:</h4>
            <div class="itemAll">
                ${childrenNodeStr}
            </div>
            <span class="slideup"><img src="${collapseImg}"></span>
        </div>`

    $('.push').append(childrenNodeStrAll)
    $('.'+className + 'box' +' .infoMsg').on('click', function(){
        const infoMsgName = $(this).attr('data-name')
        openNewWin(`information.html?type=${type}&position=${position}&name=${infoMsgName}`)
    })
    $('.'+className + 'boxAll' +' .infoMsg').on('click', function(){
        const infoMsgName = $(this).attr('data-name')
        openNewWin(`information.html?type=${type}&position=${position}&name=${infoMsgName}`)
    })
    slideToggle("."+className+"box")
}

//化验和辅检等多种类型
function renderMultRecommendInfo(icon, className,title,data, hasInfo, type, position) {
    const str = `<div class="recommendInfoWrapper ${className} clearfix">
                    <h4><img src=${icon} title="${title}" class="icon">${title}:</h4>
                    <div class="recommendInfoBox ${className + 'box'}"></div>
                </div>`
    $('.push').append(str)
    
    for(let i = 0; i < data.length; i++) {
        let childrenNodeBoxStr  = `<div class="labAndPacsWrapper ${data[i].className+'wrapper'}">
                <div class="labAndPacsBox ${data[i].className+'box'} clearfix"> 
                </div>
            </div>`
        let childrenNodeStr =  `<span class="labAndPacsTitle">${data[i].title}<i></i></span>`
        let childrenNodeItemStrAll =  '' //更多展开框中的字符串
        for(let j = 0; j < data[i].data.length; j++) {
            childrenNodeStr += `<span class="labAndPacsItem">${data[i].data[j].name}</span>`
            childrenNodeItemStrAll += `<span class="labAndPacsItem">${data[i].data[j].name}</span>`
        }
        if(data[i].data.length == 0) {
            childrenNodeStr +='<span class="recommendNull">暂无推荐</span>'
        }
        $('.'+className + 'box').append(childrenNodeBoxStr)
        $('.'+data[i].className+'box').append(childrenNodeStr)
        let childrenNodeStrAll = `<div class="${data[i].className+'boxAll'} itemAllBox">
            <h4>${data[i].title}:</h4>
            <div class="itemAll">
                ${childrenNodeItemStrAll}
                <span class="slideup"><img src="${collapseImg}"></span>
            </div>
        </div>`

        $('.push').append(childrenNodeStrAll)
        slideToggle("."+data[i].className+"box")
    }

}

function renderTreat(icon, className,title, data) {
    const str = `<div class="recommendInfoWrapper ${className} clearfix">
                    <h4><img src=${icon} title="${title}" class="icon">${title}:<span class="diagName">${msg.diag}</span></h4>
                    <div class="recommendInfoBox clearfix ${className + 'box'}"></div>
                </div>`
    $('.treat').append(str)
    const commonTreatmentInfo = data.commonTreatment&&data.commonTreatment.content || ""
    const treatmentList = data.treatment || []
    renderTreatText('commonTreatment', '一般治疗', commonTreatmentInfo, className+'box')
    renderTreatDrug('drugTreatment', '药物治疗', treatmentList, className+'box')
}

function renderTreatText(className,title,data, parentNode) {
    const childrenNodeBoxStr = `
        <div class = "treatItemBox ${className + 'box'}">
            <p class="treatItemTitle">${title}:</p>
            <div class="treatTextBox">
                <p class="${className + 'Info'} clearfix"></p>
            </div>
        </div>
    `
    $('.' + parentNode).append(childrenNodeBoxStr)
    if(!data) {
        data = '<span class="recommendNull">暂无推荐</span>'
    }
    $('.' + className+'Info').html(data)
    var commonTreatHeight = $(".commonTreatmentInfo").height()
    if(commonTreatHeight > 75){
        $(".treatTextBox").append('<span class="more">更多</span>')
    }
    $(".treat .treatTextBox").on('click',".more",function(){
        openNewWin(`treatplan.html?age=${msg.age}&sex=${msg.sex}&symptomJson=${msg.symptom}&vitalJson=${msg.vital}&lisJson=${msg.lis}&pacsJson=${msg.pacs}&diagJson=${msg.diag}&otherJson=${msg.other}&hospitalCode=${msg.hosCode}`)
      })
    
}
function renderTreatDrug(className,title,data, parentNode) {
    const childrenNodeBoxStr = `
        <div class = "treatItemBox ${className + 'box'}">
            <p class="treatItemTitle">${title}:</p>
            <div class="treatDrugBox">
                <p class="${className + 'Info'}"></p>
            </div>
        </div>
    `
    $('.' + parentNode).append(childrenNodeBoxStr)
    if(data.length ==0) {
        $('.' + className+'Info').append('<span class="recommendNull">暂无推荐</span>')
    }
    for(let i = 0; i < data.length; i++) {
        let childrenNodeStr = `<p class="drugTreatmentInfoItemBox">
            ${i+1}.${data[i].bigdrugsName}(${data[i].subdrugsName}):`
        for (let j = 0; j < data[i].medicitionsList.length; j++) {
            childrenNodeStr += `<span class="durgNameBox">${data[i].medicitionsList[j].medicitionName}`
            if(data[i].medicitionsList[j].drugsForbidden == '1') {
                childrenNodeStr += `<span>慎用</span>`
            } else if(data[i].medicitionsList[j].drugsForbidden == '2') {
                childrenNodeStr += `<span>禁用</span>`
            }
            childrenNodeStr += `<span  title="点击名称可看详细说明" class="infoMsg" data-name=${data[i].medicitionsList[j].medicitionName}></span>,</span></span>`
            childrenNodeStr += `使用率${data[i].medicitionsList[j].rate}`
            if(j === data[i].medicitionsList.length-1) {
                childrenNodeStr += ';'
            } else {
                childrenNodeStr += ','
            }
        }
        childrenNodeStr += ` </p>`
        $('.' + className+'Info').append(childrenNodeStr)
    }
    $('.' + className+'Info'+ ' .infoMsg').on('click', function(){
        const infoMsgName = $(this).attr('data-name')
        openNewWin(`information.html?type=8&position=5&name=${infoMsgName}`)
    })
    
    var drugTreatmentHeight = $(".drugTreatmentInfo").height()
    if(drugTreatmentHeight > 75){
        $(".treatDrugBox").append('<span class="more">更多</span>')
    } else if(drugTreatmentHeight > 30) {
        $(".drugTreatmentInfo").append('<span class="more">更多</span>')
    }
    $(".treat .drugTreatmentbox").on('click',".more",function(){
        openNewWin(`treatplan.html?age=${msg.age}&sex=${msg.sex}&symptomJson=${msg.symptom}&vitalJson=${msg.vital}&lisJson=${msg.lis}&pacsJson=${msg.pacs}&diagJson=${msg.diag}&otherJson=${msg.other}&hospitalCode=${msg.hosCode}`)
      })
    var treatList = $(".drugTreatmentInfo").find(".drugTreatmentInfoItemBox")
    // for(var h = 0;h < treatList.length;h++){ 
    //     if($(treatList[h]).height() > 25){
    //     $(treatList[h]).addClass('recommendInfoItemBoxLimit').append('<span class="slideDown">更多 <i></i></span>')
    //     }
    //     $(".drugTreatmentInfo").on('click',".slideDown",function(){
    //     $(this).parents(".drugTreatmentInfoItemBox ").removeClass("recommendInfoItemBoxLimit").append('<span class="slideup">收起 <i></i></span>')
    //     $(this).remove()
    //     })
    //     $(".drugTreatmentInfo").on('click',".slideup",function(){
    //     $(this).parents(".drugTreatmentInfoItemBox ").addClass("recommendInfoItemBoxLimit").append('<span class="slideDown">更多 <i></i></span>')
    //     $(this).remove()
    //     })
    // }
}

function renderRecommendConditTips(icon, className,title,data) {
    const str = `<div class="recommendInfoWrapper ${className} clearfix">
                    <h4><img src=${icon} title="${title}" class="icon">${title}:</h4>
                    <div class="recommendInfoBox  ${className + 'box'}"></div>
                </div>`
    $('.push').append(str)
    if(data.length == 0) {
        $("."+className+"box").append('<span class="recommendNull">暂无推荐</span>')
    }
    for(var k = 0;k < data.length;k++){
        var tmpBq = data[k]
        var tmpBqStr = '<p class="mayIllness">患者可能有 <span>'+tmpBq.name+'<span title="点击该名称可看详细说明" class="infoMsg"></span></span> :</p>'
        var tmpBqStr = `<p class="mayIllness">
                            患者可能有 <span class="diagNameBox">${tmpBq.name}:
                                <span title="点击该名称可看详细说明" class="infoMsg" data-name=${tmpBq.name}></span>
                            </span> 
                        </p>`
        var tmpBqDetailStr = ''
        for(var m = 0;m < tmpBq.details.length;m++){
          var tmpBqDetail = tmpBq.details[m]
          if(tmpBqDetail.type == 1){
            tmpBqDetailStr+=`<span data-url=scale.html?featureType=21&sex=${msg.sex}&lis=${JSON.stringify(msg.lis)}&diag=${msg.diag}&scaleName=${tmpBqDetail.content.name}&symptom=${msg.symptom}&other=${msg.other}&pacs=${msg.pacs}&vital=${msg.vital}&age=${msg.age}&scaleId=${tmpBqDetail.content.id} class="illnessTable">【${tmpBqDetail.content.name}】</span>`
          }
        
        }
        
        $("."+className+"box").append('<div class="conditionMain ellipse clearfix">'+tmpBqStr+'<div class="alertModal">'+tmpBqDetailStr+'</div><span class="more">更多</span></div>')
      }
      $('.mayIllness .infoMsg').on('click', function(){
        const infoMsgName = $(this).attr('data-name')
        openNewWin(`information.html?type=22&position=2&name=${infoMsgName}`)
      })
      $('.alertModal .illnessTable').on('click', function(){
        const infoMsgUrl = $(this).attr('data-url')
        openNewWin(infoMsgUrl)
      })
      $(".conditTipsbox").on('click',".more",function(){
        openNewWin(`illness.html?age=${msg.age}&sex=${msg.sex}&symptomJson=${msg.symptom}&vitalJson=${msg.vital}&lisJson=${msg.lis}&pacsJson=${msg.pacs}&diagJson=${msg.diag}&otherJson=${msg.other}&hospitalCode=${msg.hosCode}`)
      })
      bindTipsEvent()
}
function slideToggle(className){//展开收起
    const domName = $(className)
    const domNameBoxAll = $(className+'All')
    if(domName.height() > 20){
      domName.append(`<span class="slideDown"><img src="${showImg}"></span>`)
    }
    domName.on('click',".slideDown",function(){
        $(".itemAllBox").css('display', 'none')
        $(domNameBoxAll).css('display', 'block')
      
    })
    domNameBoxAll.on('click',".slideup",function(){
        $(domNameBoxAll).css('display', 'none')
    })
  }

  $(".disclaimer").on("click",function() {
    openNewWin("disclaimer.html")
  })

module.exports = {
    renderRecommendInfo,
    renderMultRecommendInfo,
    renderTreat,
    renderRecommendConditTips
}
